/*
 * API description-specific refract elements.
 * General structure:
 *
 * + Category - API, resource group
 *   + Category
 *   + Copy
 *   + Resource
 *     + Transition
 *       + Transaction
 *         + Request
 *           + Asset
 *           + Message body
 *           + Message body schema
 *         + Response
 *           + Asset
 *           + Message body
 *           + Message body schema
 *   + Transition
 *   + Data structure
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.namespace = namespace;

function namespace(options) {
  var _arr = ['http-headers', 'href-variables', 'asset', 'http-message-payload', 'http-transaction', 'transition', 'resource', 'data-structure', 'copy', 'category'];

  for (var _i = 0; _i < _arr.length; _i++) {
    var _name = _arr[_i];
    require('./elements/' + _name)(options.base);
  }
}

exports['default'] = { namespace: namespace };
//# sourceMappingURL=api-description.map