'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

exports['default'] = function (namespace) {
  var ArrayElement = namespace.getElementClass('array');

  var Resource = (function (_ArrayElement) {
    _inherits(Resource, _ArrayElement);

    function Resource() {
      _classCallCheck(this, Resource);

      _get(Object.getPrototypeOf(Resource.prototype), 'constructor', this).apply(this, arguments);
      this.element = 'resource';
    }

    _createClass(Resource, [{
      key: 'getByRel',
      value: function getByRel() {
        var rel = arguments.length <= 0 || arguments[0] === undefined ? '' : arguments[0];

        return this.filter(function (element) {
          return element.element === 'link' || element.element === 'form' || element.element === 'resource';
        }).filter(function (element) {
          return element.rels.contains(rel);
        });
      }
    }, {
      key: 'addLink',
      value: function addLink(linkAttributes) {
        var Link = namespace.getElementClass('link');
        var link = new Link();
        this.content.push(link);
        link.attributes.set(linkAttributes);
        return link;
      }
    }, {
      key: 'addForm',
      value: function addForm(formAttributes) {
        var Form = namespace.getElementClass('form');
        var form = new Form();
        this.content.push(form);
        form.attributes.set(formAttributes);
        return form;
      }
    }, {
      key: 'rels',
      get: function get() {
        var rels = this.attributes.get('rels');

        if (rels) {
          return rels;
        }

        this.attributes.set('rels', []);
        return this.attributes.get('rels');
      },
      set: function set() {
        var rels = arguments.length <= 0 || arguments[0] === undefined ? [] : arguments[0];

        this.attributes.set('rels', rels);
        return this;
      }
    }, {
      key: 'href',
      get: function get() {
        var href = this.attributes.get('href');

        if (href) {
          return href;
        }

        this.attributes.set('href', '');
        return this.attributes.get('href');
      },
      set: function set(href) {
        this.attributes.set('href', href);
        return this;
      }
    }, {
      key: 'links',
      get: function get() {
        return this.filter(function (element) {
          return element.element === 'link';
        });
      }
    }, {
      key: 'forms',
      get: function get() {
        return this.filter(function (element) {
          return element.element === 'form';
        });
      }
    }, {
      key: 'embedded',
      get: function get() {
        return this.filter(function (element) {
          return element.element === 'resource';
        });
      }
    }]);

    return Resource;
  })(ArrayElement);

  namespace.register('resource', Resource);
};

module.exports = exports['default'];
//# sourceMappingURL=resource.map